<?php
/**
	 Callbot View File
	 Start Calls from Max2Play via SIP (e.g. as fritzbox IP-Phone) to custom numbers with predefined MP3 or custom MP3
	 Good for real-time information on detected alarms
	 Start calls via http-Get Request
	
	 @Copyright 2014 Stefan Rick
	 @author Stefan Rick
	 Mail: stefan@rick-software.de
 	 Web: http://www.netzberater.de
		 
 */ 
?>											


<h1 class="entry-header">
	<?php echo _t("Callbot Setup") ?>
</h1>
<div class="entry-content">
	<?php if(isset($callbot->view->message[0])){ ?>
		<div class="ui-widget">
			<div class="ui-state-highlight ui-corner-all" style="margin-bottom: 10px; padding: 0.4em .7em;">
				<p>
					<span class="ui-icon ui-icon-info" style="float: left; margin-right: .3em;"></span>
					<?php echo implode('<br />', $callbot->view->message); ?>					
				</p>
			</div>
		</div>
	<?php } ?>
	
	<p class="ui-state-default ui-corner-all" style="padding:4px;margin-bottom:1em;">
			<span class="ui-icon ui-icon-wrench" style="float:left; margin:-2px 5px 0 0;"></span>
			<b><?php echo _t("Callbot - automatically submit voice messages to your mobile phone") ?></b></p>
	<?php echo _t("This plugin features an easy to use interface to set up and automatically start voice calls to your mobile phone. This enables you to get real-time alerts on alarm-detection and similar usage.") ?>
	<br />
	<?php echo _t("How this plugin works - Prerequisites") ?>:
	<?php echo _t("<ul class='description'><li>Install and configure the callblocker plugin to get the SIP-functionality and the connection to your SIP-Provider</li><li>Set up the messages that should be send to your mobile phone</li><li>Start the calls by using the http-Request from your local network (e.g. homematic-CCU or home automatisation tools)</li></ul>") ?> 
	<br /> 
	<form action="" method="get">
		<input type="hidden" id="action" name="action" value="" />				
		
		<div class="optiondetails"> 
			<table class="settings">
			  <tr>
				<td><?php echo _t("Activated") ?></td>
				<td><input type="checkbox" name="config[enabled]" value="1" <?php if($callbot->config->enabled > 0) echo "checked" ?> /></td>
				<td><?php echo _t("Start outgoing calls by opening the URL (HTTP-Request)") ?></td> 
			  </tr>
			  <tr>
				<td><?php echo _t("Phone number") ?></td>
				<td><input type="text" name="config[phonenumber]" value="<?php echo $callbot->config->phonenumber ?>" /></td>
				<td><?php echo _t("Enter the phonenumber that will be called.") ?></td> 
			  </tr>
			  <tr>
				<td><?php echo _t("Record a voice message") ?></td>
				<td><select name="wavfile-record">
						<option value="1"><?php echo _t("Message") ?> 1</option>
						<option value="2"><?php echo _t("Message") ?> 2</option>
					</select>
					<input type="button" id="record" name="<?php echo _t("record") ?>" onclick="document.getElementById('action').value='record';submit();" value="<?php echo _t("Start recording") ?>" />
				</td>
				<td><?php echo _t("By sending the parameter 'wavfile=1' the corresponding message (in this the first) is played. The voice message is saved as a WAV file and has running time of maximally ten seconds.") ?></td> 
			  </tr>	 
			 
			</table>			
			<input type="button" id="save" name="<?php echo _("save") ?>" onclick="document.getElementById('action').value='save';submit();" value="<?php echo _("save") ?>" />		
		</div>	
    <br /><br />
    <?php echo _t("Here you can start a test call to the number that is saved above.") ?><br />
	<select name="wavfile">
		<option value="1"><?php echo _t("Message") ?> 1</option>
		<option value="2"><?php echo _t("Message") ?> 2</option>
	</select>
	<input type="button" id="startcall" name="<?php echo _("startcall") ?>" onclick="document.getElementById('action').value='startcall';submit();" value="<?php echo _t("Start testcall") ?>" />	
	<br /><br />
	<?php echo str_replace('$SERVER', $_SERVER['HTTP_HOST'], _t('The URL to request other scripts and from other computers in the local network is: http://$SERVER/plugins/callbot/controller/Setup.php?action=startcall&wavfile=1')); ?>
	</form>
	
	<br /><br />
	<a href="#javascript" onclick="document.getElementById('debug').style.display='';return false;"><?php echo _("DEBUG Informations") ?></a>
	<textarea id="debug" rows="30" cols="70" style="display:none;"><?php foreach ($callbot->view->debug as $key => $debug) {
			echo "#### ". $key. " ####\n"; 
			 echo $debug." \n\n"; 
		 }?>
	</textarea>
</div>